#include "gpio_pwm_carship.h"
#include "common.h"

// 定义 PWM 引脚的 WiringPi 编号
#define PWM_PIN_SPEED 21
#define PWM_PIN_CHANGE 2

int count_mode = 0;

const int gpioWPi[] = {5, 6, 7, 10, 16, 20, 22, 23, 24, 25, 26, 27};//车能使用高低引脚
const int gpioWPi_ship[] = {5, 6, 7,10, 16, 20, 22, 23, 24,25,26, 27};//船能使用高低引脚

void pin_init() {//初始化引脚,车和坦克共用
    int gpioCount = sizeof(gpioWPi) / sizeof(gpioWPi[0]);
    // 设置所有GPIO为输出模式
    for(int i = 0; i < gpioCount; i++) {
        pinMode(gpioWPi[i], OUTPUT);
        digitalWrite(gpioWPi[i], LOW);  // 初始化所有引脚为低电平
    }
    
}

void pin_all_default() {//全部至低电平,车和坦克共用
	int gpioCount = sizeof(gpioWPi) / sizeof(gpioWPi[0]);
	for (int i=0;i<gpioCount;i++)
	{
		digitalWrite(gpioWPi[i], LOW);
	}
}

void pin_ship_init() {//初始化引脚,车和坦克共用
    int gpioCount = sizeof(gpioWPi_ship) / sizeof(gpioWPi_ship[0]);
    // 设置所有GPIO为输出模式
    for(int i = 0; i < gpioCount; i++) {
        pinMode(gpioWPi_ship[i], OUTPUT);
        digitalWrite(gpioWPi_ship[i], LOW);  // 初始化所有引脚为低电平
    }
    
}

void pin_all_ship_default() {//全部至低电平,船用
	int gpioCount = sizeof(gpioWPi_ship) / sizeof(gpioWPi_ship[0]);
	for (int i=0;i<gpioCount;i++)
	{
		digitalWrite(gpioWPi_ship[i], LOW);
	}
}


void pin_value(int pin,int value) {	
	if(value==1) {
		digitalWrite(pin, HIGH);
		printf("pin:%d,%d\n",pin,HIGH);
	}else if(value==0) {
		digitalWrite(pin, LOW);
		printf("pin:%d,%d\n",pin,LOW);
	}
	
}

void pwm_speed() {
    int pwm_clock = 24000000 / (50 * 1000);// 定义 PWM 频率为 50Hz
    pinMode(PWM_PIN_SPEED,PWM_OUTPUT);
    pinMode(PWM_PIN_CHANGE,PWM_OUTPUT);
    pwmSetClock(PWM_PIN_SPEED,pwm_clock);//=19200*1000/(hz*2000)
    pwmSetRange(PWM_PIN_SPEED,1000);//占空比范围
    pwmSetClock(PWM_PIN_CHANGE,pwm_clock);//=19200*1000/(hz*2000)
    pwmSetRange(PWM_PIN_CHANGE,1000);//占空比范围
    
}

void midde_pwm() {//车停止pwm值
    pwmWrite(PWM_PIN_SPEED,75);
    pwmWrite(PWM_PIN_CHANGE,70);
}

void ship_stop_pwm() {//船停止pwm值
    pwmWrite(PWM_PIN_SPEED,0);
    pwmWrite(PWM_PIN_CHANGE,0);
	digitalWrite(5, LOW);
	digitalWrite(7, LOW);
	digitalWrite(24, LOW);
	digitalWrite(26, LOW);
}


/*车的速度转向函数*/
void mode_1_flont(unsigned char gval) {
	if (gval < 50) {
		pwmWrite(PWM_PIN_SPEED, 75);
	} else if (gval <= 55) {
		pwmWrite(PWM_PIN_SPEED, 72);
	} else if (gval <= 60) {
		pwmWrite(PWM_PIN_SPEED, 72);
	} else if (gval <= 65) {
		pwmWrite(PWM_PIN_SPEED, 70);
	} else if (gval <= 70) {
		pwmWrite(PWM_PIN_SPEED, 70);
	} else if (gval <= 75) {
		pwmWrite(PWM_PIN_SPEED, 69);
	} else if (gval <= 90) {
		pwmWrite(PWM_PIN_SPEED, 68);
	} else if (gval <= 100) {
		pwmWrite(PWM_PIN_SPEED, 68);
	} else if (gval <= 110) {
		pwmWrite(PWM_PIN_SPEED, 66);
	} else if (gval <= 120) {
		pwmWrite(PWM_PIN_SPEED, 65);
	} else if (gval <= 130) {
		pwmWrite(PWM_PIN_SPEED, 64);
	} else if (gval <= 140) {
		pwmWrite(PWM_PIN_SPEED, 62);
	} else if (gval <= 150) {
		pwmWrite(PWM_PIN_SPEED, 60);
	} else if (gval <= 160) {
		pwmWrite(PWM_PIN_SPEED, 59);
	} else if (gval <= 170) {
		pwmWrite(PWM_PIN_SPEED, 58);
	} else if (gval <= 180) {
		pwmWrite(PWM_PIN_SPEED, 57);
	} else if (gval <= 190) {
		pwmWrite(PWM_PIN_SPEED, 56);
	} else if (gval <= 200) {
		pwmWrite(PWM_PIN_SPEED, 55);
	}    
}

void mode_2_back(unsigned char gval) {
   	if(gval<50) {
		pwmWrite(PWM_PIN_SPEED,75);
	}else if(50<=gval&&gval<=55) {
		pwmWrite(PWM_PIN_SPEED,76);
	}else if(55<gval&&gval<=60) {
		pwmWrite(PWM_PIN_SPEED,77);
	}else if(60<gval&&gval<=65) {
		pwmWrite(PWM_PIN_SPEED,77);
	}else if(65<gval&&gval<=70) {
		pwmWrite(PWM_PIN_SPEED,78);
	}else if(70<gval&&gval<=75) {
		pwmWrite(PWM_PIN_SPEED,78);
	}else if(75<gval&&gval<=90) {
		pwmWrite(PWM_PIN_SPEED,79);
	}else if(90<gval&&gval<=100) {
		pwmWrite(PWM_PIN_SPEED,80);  
	}else if(110<gval&&gval<=120) {
		pwmWrite(PWM_PIN_SPEED,81); 
	}else if(120<gval&&gval<=130) {
		pwmWrite(PWM_PIN_SPEED,82); 
	}else if(130<gval&&gval<=140) {
		pwmWrite(PWM_PIN_SPEED,83); 
	}else if(140<gval&&gval<=150) {
		pwmWrite(PWM_PIN_SPEED,84); 
	}else if(150<gval&&gval<=160) {
		pwmWrite(PWM_PIN_SPEED,85); 
	}else if(160<gval&&gval<=170) {
		pwmWrite(PWM_PIN_SPEED,86); 
	}else if(170<gval&&gval<=180) {
		pwmWrite(PWM_PIN_SPEED,87); 
	}else if(180<gval&&gval<=190) {
		pwmWrite(PWM_PIN_SPEED,88); 
	}else if(190<gval&&gval<=200) {
		pwmWrite(PWM_PIN_SPEED,89); 
	}
}

void mode_3_left(unsigned char gval) {
	if (gval < 45) {
		pwmWrite(PWM_PIN_CHANGE, 70);
	} else if (gval <= 51) {
		pwmWrite(PWM_PIN_CHANGE, 80);
	} else if (gval <= 57) {
		pwmWrite(PWM_PIN_CHANGE, 83);
	} else if (gval <= 63) {
		pwmWrite(PWM_PIN_CHANGE, 85);
	} else if (gval <= 69) {
		pwmWrite(PWM_PIN_CHANGE, 90);
	} else if (gval <= 75) {
		pwmWrite(PWM_PIN_CHANGE, 95);
	} else if (gval <= 81) {
		pwmWrite(PWM_PIN_CHANGE, 98);
	} else if (gval <= 87) {
		pwmWrite(PWM_PIN_CHANGE, 100);
	} else if (gval <= 93) {
		pwmWrite(PWM_PIN_CHANGE, 102);
	} else if (gval <= 100) {
		pwmWrite(PWM_PIN_CHANGE, 105);
	}
		
}

void mode_4_right(unsigned char gval) {
	if (gval < 45) {
		pwmWrite(PWM_PIN_CHANGE, 70);
	} else if (gval <= 51) {
		pwmWrite(PWM_PIN_CHANGE, 60);
	} else if (gval <= 57) {
		pwmWrite(PWM_PIN_CHANGE, 57);
	} else if (gval <= 63) {
		pwmWrite(PWM_PIN_CHANGE, 54);
	} else if (gval <= 69) {
		pwmWrite(PWM_PIN_CHANGE, 50);
	} else if (gval <= 75) {
		pwmWrite(PWM_PIN_CHANGE, 45);
	} else if (gval <= 81) {
		pwmWrite(PWM_PIN_CHANGE, 42);
	} else if (gval <= 87) {
		pwmWrite(PWM_PIN_CHANGE, 40);
	} else if (gval <= 93) {
		pwmWrite(PWM_PIN_CHANGE, 38);
	} else if (gval <= 100) {
		pwmWrite(PWM_PIN_CHANGE, 35);
	}    
}

void speed_change(unsigned char *buf) {//车速度和转向引脚数值处理函数
    unsigned char mode=buf[1];
    unsigned char val=buf[2];
    switch(mode){
        case 1:			
		mode_1_flont(val);					 
			break;
		case 2:	
			mode_2_back(val);
			break;
		case 3:
			mode_3_left(val);
			break;
		case 4:
			mode_4_right(val);
			break; 
        default:
			break;
    } 
}


/*船的速度转向*/
void ship_mode_flont(unsigned char gval) {
	digitalWrite(5, HIGH);
	digitalWrite(7, LOW);
	digitalWrite(24, HIGH);
	digitalWrite(26, LOW);
	if (gval <= 50) {
		pwmWrite(PWM_PIN_SPEED, 0);
		pwmWrite(PWM_PIN_CHANGE, 0);
	} else if (gval <= 55) {
		pwmWrite(PWM_PIN_SPEED, 200);
		pwmWrite(PWM_PIN_CHANGE, 200);
	} else if (gval <= 60) {
		pwmWrite(PWM_PIN_SPEED, 300);
		pwmWrite(PWM_PIN_CHANGE, 300);
	} else if (gval <= 65) {
		pwmWrite(PWM_PIN_SPEED, 350);
		pwmWrite(PWM_PIN_CHANGE, 350);
	} else if (gval <= 70) {
		pwmWrite(PWM_PIN_SPEED, 400);
		pwmWrite(PWM_PIN_CHANGE, 400);
	} else if (gval <= 75) {
		pwmWrite(PWM_PIN_SPEED, 450);
		pwmWrite(PWM_PIN_CHANGE, 450);
	} else if (gval <= 90) {
		pwmWrite(PWM_PIN_SPEED, 500);
		pwmWrite(PWM_PIN_CHANGE, 500);
	} else if (gval <= 100) {
		pwmWrite(PWM_PIN_SPEED, 550);
		pwmWrite(PWM_PIN_CHANGE, 550);
	} else if (gval <= 110) {
		pwmWrite(PWM_PIN_SPEED, 600);
		pwmWrite(PWM_PIN_CHANGE, 600);
	} else if (gval <= 120) {
		pwmWrite(PWM_PIN_SPEED, 650);
		pwmWrite(PWM_PIN_CHANGE, 650);
	} else if (gval <= 130) {
		pwmWrite(PWM_PIN_SPEED, 700);
		pwmWrite(PWM_PIN_CHANGE, 700);
	} else if (gval <= 140) {
		pwmWrite(PWM_PIN_SPEED, 750);
		pwmWrite(PWM_PIN_CHANGE, 750);
	} else if (gval <= 150) {
		pwmWrite(PWM_PIN_SPEED, 800);
		pwmWrite(PWM_PIN_CHANGE, 800);
	} else if (gval <= 160) {
		pwmWrite(PWM_PIN_SPEED, 850);
		pwmWrite(PWM_PIN_CHANGE, 850);
	} else if (gval <= 170) {
		pwmWrite(PWM_PIN_SPEED, 900);
		pwmWrite(PWM_PIN_CHANGE, 900);
	} else if (gval <= 180) {
		pwmWrite(PWM_PIN_SPEED, 950);
		pwmWrite(PWM_PIN_CHANGE, 950);
	} else if (gval <= 190) {
		pwmWrite(PWM_PIN_SPEED, 1000);
		pwmWrite(PWM_PIN_CHANGE, 1000);
	} else if (gval <= 200) {
		pwmWrite(PWM_PIN_SPEED, 1000);
		pwmWrite(PWM_PIN_CHANGE, 1000);
	}    
}

void ship_mode_back(unsigned char gval)
{
	digitalWrite(5, LOW);
	digitalWrite(7, HIGH);
	digitalWrite(24, LOW);
	digitalWrite(26,HIGH );
	if (gval <= 50) {
		pwmWrite(PWM_PIN_SPEED, 0);
		pwmWrite(PWM_PIN_CHANGE, 0);
	} else if (gval <= 55) {
		pwmWrite(PWM_PIN_SPEED, 200);
		pwmWrite(PWM_PIN_CHANGE, 200);
	} else if (gval <= 60) {
		pwmWrite(PWM_PIN_SPEED, 300);
		pwmWrite(PWM_PIN_CHANGE, 300);
	} else if (gval <= 65) {
		pwmWrite(PWM_PIN_SPEED, 350);
		pwmWrite(PWM_PIN_CHANGE, 350);
	} else if (gval <= 70) {
		pwmWrite(PWM_PIN_SPEED, 400);
		pwmWrite(PWM_PIN_CHANGE, 400);
	} else if (gval <= 75) {
		pwmWrite(PWM_PIN_SPEED, 450);
		pwmWrite(PWM_PIN_CHANGE, 450);
	} else if (gval <= 90) {
		pwmWrite(PWM_PIN_SPEED, 500);
		pwmWrite(PWM_PIN_CHANGE, 500);
	} else if (gval <= 100) {
		pwmWrite(PWM_PIN_SPEED, 550);
		pwmWrite(PWM_PIN_CHANGE, 550);
	} else if (gval <= 110) {
		pwmWrite(PWM_PIN_SPEED, 600);
		pwmWrite(PWM_PIN_CHANGE, 600);
	} else if (gval <= 120) {
		pwmWrite(PWM_PIN_SPEED, 650);
		pwmWrite(PWM_PIN_CHANGE, 650);
	} else if (gval <= 130) {
		pwmWrite(PWM_PIN_SPEED, 700);
		pwmWrite(PWM_PIN_CHANGE, 700);
	} else if (gval <= 140) {
		pwmWrite(PWM_PIN_SPEED, 750);
		pwmWrite(PWM_PIN_CHANGE, 750);
	} else if (gval <= 150) {
		pwmWrite(PWM_PIN_SPEED, 800);
		pwmWrite(PWM_PIN_CHANGE, 800);
	} else if (gval <= 160) {
		pwmWrite(PWM_PIN_SPEED, 850);
		pwmWrite(PWM_PIN_CHANGE, 850);
	} else if (gval <= 170) {
		pwmWrite(PWM_PIN_SPEED, 900);
		pwmWrite(PWM_PIN_CHANGE, 900);
	} else if (gval <= 180) {
		pwmWrite(PWM_PIN_SPEED, 950);
		pwmWrite(PWM_PIN_CHANGE, 950);
	} else if (gval <= 190) {
		pwmWrite(PWM_PIN_SPEED, 1000);
		pwmWrite(PWM_PIN_CHANGE, 1000);
	} else if (gval <= 200) {
		pwmWrite(PWM_PIN_SPEED, 1000);
		pwmWrite(PWM_PIN_CHANGE, 1000);
	}  
}

void ship_mode_left_flont(unsigned char gval) {
    
	digitalWrite(24, HIGH);
	digitalWrite(26, LOW);
	digitalWrite(5, LOW);
	digitalWrite(7, LOW);
	if (gval <= 50) {
		pwmWrite(PWM_PIN_SPEED, 0);
		pwmWrite(PWM_PIN_CHANGE, 0);
	} else if (gval <= 55) {
		pwmWrite(PWM_PIN_SPEED, 200);
		pwmWrite(PWM_PIN_CHANGE, 200);
	} else if (gval <= 60) {
		pwmWrite(PWM_PIN_SPEED, 300);
		pwmWrite(PWM_PIN_CHANGE, 300);
	} else if (gval <= 65) {
		pwmWrite(PWM_PIN_SPEED, 350);
		pwmWrite(PWM_PIN_CHANGE, 350);
	} else if (gval <= 70) {
		pwmWrite(PWM_PIN_SPEED, 400);
		pwmWrite(PWM_PIN_CHANGE, 400);
	} else if (gval <= 75) {
		pwmWrite(PWM_PIN_SPEED, 450);
		pwmWrite(PWM_PIN_CHANGE, 450);
	} else if (gval <= 90) {
		pwmWrite(PWM_PIN_SPEED, 500);
		pwmWrite(PWM_PIN_CHANGE, 500);
	} else if (gval <= 100) {
		pwmWrite(PWM_PIN_SPEED, 550);
		pwmWrite(PWM_PIN_CHANGE, 550);
	} else if (gval <= 110) {
		pwmWrite(PWM_PIN_SPEED, 600);
		pwmWrite(PWM_PIN_CHANGE, 600);
	} else if (gval <= 120) {
		pwmWrite(PWM_PIN_SPEED, 650);
		pwmWrite(PWM_PIN_CHANGE, 650);
	} else if (gval <= 130) {
		pwmWrite(PWM_PIN_SPEED, 700);
		pwmWrite(PWM_PIN_CHANGE, 700);
	} else if (gval <= 140) {
		pwmWrite(PWM_PIN_SPEED, 750);
		pwmWrite(PWM_PIN_CHANGE, 750);
	} else if (gval <= 150) {
		pwmWrite(PWM_PIN_SPEED, 800);
		pwmWrite(PWM_PIN_CHANGE, 800);
	} else if (gval <= 160) {
		pwmWrite(PWM_PIN_SPEED, 850);
		pwmWrite(PWM_PIN_CHANGE, 850);
	} else if (gval <= 170) {
		pwmWrite(PWM_PIN_SPEED, 900);
		pwmWrite(PWM_PIN_CHANGE, 900);
	} else if (gval <= 180) {
		pwmWrite(PWM_PIN_SPEED, 950);
		pwmWrite(PWM_PIN_CHANGE, 950);
	} else if (gval <= 190) {
		pwmWrite(PWM_PIN_SPEED, 1000);
		pwmWrite(PWM_PIN_CHANGE, 1000);
	} else if (gval <= 200) {
		pwmWrite(PWM_PIN_SPEED, 1000);
		pwmWrite(PWM_PIN_CHANGE, 1000);
	} 
	
}

void ship_mode_right_flont(unsigned char gval) {
   digitalWrite(5, HIGH);
	digitalWrite(7, LOW);
	digitalWrite(24, LOW);
	digitalWrite(26, LOW);
	if (gval <= 50) {
		pwmWrite(PWM_PIN_SPEED, 0);
		pwmWrite(PWM_PIN_CHANGE, 0);
	} else if (gval <= 55) {
		pwmWrite(PWM_PIN_SPEED, 200);
		pwmWrite(PWM_PIN_CHANGE, 200);
	} else if (gval <= 60) {
		pwmWrite(PWM_PIN_SPEED, 300);
		pwmWrite(PWM_PIN_CHANGE, 300);
	} else if (gval <= 65) {
		pwmWrite(PWM_PIN_SPEED, 350);
		pwmWrite(PWM_PIN_CHANGE, 350);
	} else if (gval <= 70) {
		pwmWrite(PWM_PIN_SPEED, 400);
		pwmWrite(PWM_PIN_CHANGE, 400);
	} else if (gval <= 75) {
		pwmWrite(PWM_PIN_SPEED, 450);
		pwmWrite(PWM_PIN_CHANGE, 450);
	} else if (gval <= 90) {
		pwmWrite(PWM_PIN_SPEED, 500);
		pwmWrite(PWM_PIN_CHANGE, 500);
	} else if (gval <= 100) {
		pwmWrite(PWM_PIN_SPEED, 550);
		pwmWrite(PWM_PIN_CHANGE, 550);
	} else if (gval <= 110) {
		pwmWrite(PWM_PIN_SPEED, 600);
		pwmWrite(PWM_PIN_CHANGE, 600);
	} else if (gval <= 120) {
		pwmWrite(PWM_PIN_SPEED, 650);
		pwmWrite(PWM_PIN_CHANGE, 650);
	} else if (gval <= 130) {
		pwmWrite(PWM_PIN_SPEED, 700);
		pwmWrite(PWM_PIN_CHANGE, 700);
	} else if (gval <= 140) {
		pwmWrite(PWM_PIN_SPEED, 750);
		pwmWrite(PWM_PIN_CHANGE, 750);
	} else if (gval <= 150) {
		pwmWrite(PWM_PIN_SPEED, 800);
		pwmWrite(PWM_PIN_CHANGE, 800);
	} else if (gval <= 160) {
		pwmWrite(PWM_PIN_SPEED, 850);
		pwmWrite(PWM_PIN_CHANGE, 850);
	} else if (gval <= 170) {
		pwmWrite(PWM_PIN_SPEED, 900);
		pwmWrite(PWM_PIN_CHANGE, 900);
	} else if (gval <= 180) {
		pwmWrite(PWM_PIN_SPEED, 950);
		pwmWrite(PWM_PIN_CHANGE, 950);
	} else if (gval <= 190) {
		pwmWrite(PWM_PIN_SPEED, 1000);
		pwmWrite(PWM_PIN_CHANGE, 1000);
	} else if (gval <= 200) {
		pwmWrite(PWM_PIN_SPEED, 1000);
		pwmWrite(PWM_PIN_CHANGE, 1000);
	} 
}

void ship_mode_left_back(unsigned char gval) {
    digitalWrite(5, LOW);
	digitalWrite(7, LOW);
	digitalWrite(24, LOW);
	digitalWrite(26,HIGH );
	if (gval <= 50) {
		pwmWrite(PWM_PIN_SPEED, 0);
		pwmWrite(PWM_PIN_CHANGE, 0);
	} else if (gval <= 55) {
		pwmWrite(PWM_PIN_SPEED, 200);
		pwmWrite(PWM_PIN_CHANGE, 200);
	} else if (gval <= 60) {
		pwmWrite(PWM_PIN_SPEED, 300);
		pwmWrite(PWM_PIN_CHANGE, 300);
	} else if (gval <= 65) {
		pwmWrite(PWM_PIN_SPEED, 350);
		pwmWrite(PWM_PIN_CHANGE, 350);
	} else if (gval <= 70) {
		pwmWrite(PWM_PIN_SPEED, 400);
		pwmWrite(PWM_PIN_CHANGE, 400);
	} else if (gval <= 75) {
		pwmWrite(PWM_PIN_SPEED, 450);
		pwmWrite(PWM_PIN_CHANGE, 450);
	} else if (gval <= 90) {
		pwmWrite(PWM_PIN_SPEED, 500);
		pwmWrite(PWM_PIN_CHANGE, 500);
	} else if (gval <= 100) {
		pwmWrite(PWM_PIN_SPEED, 550);
		pwmWrite(PWM_PIN_CHANGE, 550);
	} else if (gval <= 110) {
		pwmWrite(PWM_PIN_SPEED, 600);
		pwmWrite(PWM_PIN_CHANGE, 600);
	} else if (gval <= 120) {
		pwmWrite(PWM_PIN_SPEED, 650);
		pwmWrite(PWM_PIN_CHANGE, 650);
	} else if (gval <= 130) {
		pwmWrite(PWM_PIN_SPEED, 700);
		pwmWrite(PWM_PIN_CHANGE, 700);
	} else if (gval <= 140) {
		pwmWrite(PWM_PIN_SPEED, 750);
		pwmWrite(PWM_PIN_CHANGE, 750);
	} else if (gval <= 150) {
		pwmWrite(PWM_PIN_SPEED, 800);
		pwmWrite(PWM_PIN_CHANGE, 800);
	} else if (gval <= 160) {
		pwmWrite(PWM_PIN_SPEED, 850);
		pwmWrite(PWM_PIN_CHANGE, 850);
	} else if (gval <= 170) {
		pwmWrite(PWM_PIN_SPEED, 900);
		pwmWrite(PWM_PIN_CHANGE, 900);
	} else if (gval <= 180) {
		pwmWrite(PWM_PIN_SPEED, 950);
		pwmWrite(PWM_PIN_CHANGE, 950);
	} else if (gval <= 190) {
		pwmWrite(PWM_PIN_SPEED, 1000);
		pwmWrite(PWM_PIN_CHANGE, 1000);
	} else if (gval <= 200) {
		pwmWrite(PWM_PIN_SPEED, 1000);
		pwmWrite(PWM_PIN_CHANGE, 1000);
	}
	
}
void ship_mode_right_back(unsigned char gval) {
	digitalWrite(5, LOW);
	digitalWrite(7, HIGH);
	digitalWrite(24, LOW);
	digitalWrite(26,LOW );
	if (gval < 50) {
		pwmWrite(PWM_PIN_SPEED, 0);
		pwmWrite(PWM_PIN_CHANGE, 0);
	} else if (gval <= 55) {
		pwmWrite(PWM_PIN_SPEED, 200);
		pwmWrite(PWM_PIN_CHANGE, 200);
	} else if (gval <= 60) {
		pwmWrite(PWM_PIN_SPEED, 300);
		pwmWrite(PWM_PIN_CHANGE, 300);
	} else if (gval <= 65) {
		pwmWrite(PWM_PIN_SPEED, 350);
		pwmWrite(PWM_PIN_CHANGE, 350);
	} else if (gval <= 70) {
		pwmWrite(PWM_PIN_SPEED, 400);
		pwmWrite(PWM_PIN_CHANGE, 400);
	} else if (gval <= 75) {
		pwmWrite(PWM_PIN_SPEED, 450);
		pwmWrite(PWM_PIN_CHANGE, 450);
	} else if (gval <= 90) {
		pwmWrite(PWM_PIN_SPEED, 500);
		pwmWrite(PWM_PIN_CHANGE, 500);
	} else if (gval <= 100) {
		pwmWrite(PWM_PIN_SPEED, 550);
		pwmWrite(PWM_PIN_CHANGE, 550);
	} else if (gval <= 110) {
		pwmWrite(PWM_PIN_SPEED, 600);
		pwmWrite(PWM_PIN_CHANGE, 600);
	} else if (gval <= 120) {
		pwmWrite(PWM_PIN_SPEED, 650);
		pwmWrite(PWM_PIN_CHANGE, 650);
	} else if (gval <= 130) {
		pwmWrite(PWM_PIN_SPEED, 700);
		pwmWrite(PWM_PIN_CHANGE, 700);
	} else if (gval <= 140) {
		pwmWrite(PWM_PIN_SPEED, 750);
		pwmWrite(PWM_PIN_CHANGE, 750);
	} else if (gval <= 150) {
		pwmWrite(PWM_PIN_SPEED, 800);
		pwmWrite(PWM_PIN_CHANGE, 800);
	} else if (gval <= 160) {
		pwmWrite(PWM_PIN_SPEED, 850);
		pwmWrite(PWM_PIN_CHANGE, 850);
	} else if (gval <= 170) {
		pwmWrite(PWM_PIN_SPEED, 900);
		pwmWrite(PWM_PIN_CHANGE, 900);
	} else if (gval <= 180) {
		pwmWrite(PWM_PIN_SPEED, 950);
		pwmWrite(PWM_PIN_CHANGE, 950);
	} else if (gval <= 190) {
		pwmWrite(PWM_PIN_SPEED, 1000);
		pwmWrite(PWM_PIN_CHANGE, 1000);
	} else if (gval <= 200) {
		pwmWrite(PWM_PIN_SPEED, 1000);
		pwmWrite(PWM_PIN_CHANGE, 1000);
	}
	
}

typedef struct {
    unsigned char buf[3];
} ShipSpeedParams;

void ship_speed_change(void *arg) {//船速度和转向引脚数值处理函数
	ShipSpeedParams *params = (ShipSpeedParams *)arg;
	unsigned char *buf = params->buf;
    unsigned char mode = buf[1];
    unsigned char val = buf[2];
	if(val==0)count_mode = 0;
	if(mode == 1 && count_mode == 0) ship_mode_flont(val);
	if(mode == 2 && count_mode == 0) ship_mode_back(val);
	if(mode == 3) count_mode = 3;
	if(mode == 4) count_mode = 4;
	if(val==0)count_mode = 0;
	if(mode == 1 && count_mode == 3 ){
		ship_mode_left_flont(val);
	}else if(mode == 1 && count_mode == 4) {
		ship_mode_right_flont(val);
	}
	if(mode == 2 && count_mode == 3 ){
		ship_mode_left_back(val);
	}else if(mode == 2 && count_mode == 4) {
		ship_mode_right_back(val);
	}


    // switch(count_mode) {
    //     case 1:			
	// 		ship_mode_1_flont(val);					 
	// 		break;
	// 	case 2:	
	// 		ship_mode_2_back(val);
	// 		break;
	// 	case 3:
	// 		ship_mode_3_left(val);
	// 		break;
	// 	case 4:
	// 		ship_mode_4_right(val);
	// 		break; 
    //     default:
	// 		break;
    // }
	
    
}


